# printing_python_3_strings.py
# a program that demonstrates printing of various Python 3 strings


def main():
    outfile = open('string_output_including_crlf.txt', 'w', encoding='utf-8')
    print(outfile, 'is open.')

    # regular text
    print('regular text:', 'AbCdEfG', file=outfile)

    # embedded apostrophe
    print('embedded apostrophe1:', "Don't worry. Be Happy.", file=outfile)
    print('embedded apostrophe2:', 'Don\'t Worry. Be Happy.', file=outfile)

    # embedded quote mark
    print('embedded quote mark1:', 'We are looking for "closure" on this terrible issue.', file=outfile)
    print('embedded quote mark2:', "We are looking for \"closure\" on this terrible issue.", file=outfile)

    # ending lines in Python
    print('implicit line ending:', 'How now brown cow?', file=outfile)
    print('explicit line ending:', 'How now brown cow?', end='\n', file=outfile)
    print('explicit line ending with CRLF:', 'How now brown cow?', end='\r\n', file=outfile)

    # tabbing
    print('tabs entered from keyboard:', 'first second  third   fourth', file=outfile)
    print('explicit tabs using escape sequence:', 'first\tsecond\tthird\tfourth', file=outfile)

    # backslash
    print('backslash:', '\\ is a backslash.', file=outfile)

    # unicode symbols not on keyboard
    print('unicode symbol not on keyboard:', '\u798F is the character Fu, meaning fortune or good luck.', file=outfile)

    outfile.close()
    print(outfile, 'is closed.')


main()
