# raw_string_regular_expression_demo.py
# Count lines containing a target string in the input file.

import re


def main():
    text_filename = 'string_output_including_crlf.txt'

    pattern_to_test = re.compile(r'AbCdEfG')
    search_file_using(text_filename, pattern_to_test)

    pattern_to_test = re.compile(r"'")
    search_file_using(text_filename, pattern_to_test)

    pattern_to_test = re.compile(r'"')
    search_file_using(text_filename, pattern_to_test)

    pattern_to_test = re.compile(r'\n')
    search_file_using(text_filename, pattern_to_test)

    pattern_to_test = re.compile(r'\r\n')
    search_file_using(text_filename, pattern_to_test)

    pattern_to_test = re.compile(r'\t')
    search_file_using(text_filename, pattern_to_test)

    pattern_to_test = re.compile(r'\\')
    search_file_using(text_filename, pattern_to_test)

    pattern_to_test = re.compile(r'\u798F')
    search_file_using(text_filename, pattern_to_test)


def search_file_using(this_file_name, this_pattern):
    print('\n\nSearching', this_file_name, 'using', str(this_pattern))
    infile = open(this_file_name, 'r', encoding='utf-8')
    line_count = 0
    match_count = 0
    for line in infile:
        line_count += 1
        if this_pattern.search(line):
            match_count += 1
            print('Line', line_count, ': ', line[: -1])
    print(match_count, 'lines were matched using this pattern.')
    infile.close()


main()
